<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>TIOVX Tutorials: vx_tutorial_image_crop_roi.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<img src="ti_logo.gif">
<tr bgcolor="#CCCCCC"> 
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
    </ul>
  </div>
<h1>vx_tutorial_image_crop_roi.c</h1><a href="vx__tutorial__image__crop__roi_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">*</span>
<a name="l00003"></a>00003 <span class="comment">* Copyright (c) 2017 Texas Instruments Incorporated</span>
<a name="l00004"></a>00004 <span class="comment">*</span>
<a name="l00005"></a>00005 <span class="comment">* All rights reserved not granted herein.</span>
<a name="l00006"></a>00006 <span class="comment">*</span>
<a name="l00007"></a>00007 <span class="comment">* Limited License.</span>
<a name="l00008"></a>00008 <span class="comment">*</span>
<a name="l00009"></a>00009 <span class="comment">* Texas Instruments Incorporated grants a world-wide, royalty-free, non-exclusive</span>
<a name="l00010"></a>00010 <span class="comment">* license under copyrights and patents it now or hereafter owns or controls to make,</span>
<a name="l00011"></a>00011 <span class="comment">* have made, use, import, offer to sell and sell (&quot;Utilize&quot;) this software subject to the</span>
<a name="l00012"></a>00012 <span class="comment">* terms herein.  With respect to the foregoing patent license, such license is granted</span>
<a name="l00013"></a>00013 <span class="comment">* solely to the extent that any such patent is necessary to Utilize the software alone.</span>
<a name="l00014"></a>00014 <span class="comment">* The patent license shall not apply to any combinations which include this software,</span>
<a name="l00015"></a>00015 <span class="comment">* other than combinations with devices manufactured by or for TI (&quot;TI Devices&quot;).</span>
<a name="l00016"></a>00016 <span class="comment">* No hardware patent is licensed hereunder.</span>
<a name="l00017"></a>00017 <span class="comment">*</span>
<a name="l00018"></a>00018 <span class="comment">* Redistributions must preserve existing copyright notices and reproduce this license</span>
<a name="l00019"></a>00019 <span class="comment">* (including the above copyright notice and the disclaimer and (if applicable) source</span>
<a name="l00020"></a>00020 <span class="comment">* code license limitations below) in the documentation and/or other materials provided</span>
<a name="l00021"></a>00021 <span class="comment">* with the distribution</span>
<a name="l00022"></a>00022 <span class="comment">*</span>
<a name="l00023"></a>00023 <span class="comment">* Redistribution and use in binary form, without modification, are permitted provided</span>
<a name="l00024"></a>00024 <span class="comment">* that the following conditions are met:</span>
<a name="l00025"></a>00025 <span class="comment">*</span>
<a name="l00026"></a>00026 <span class="comment">* *       No reverse engineering, decompilation, or disassembly of this software is</span>
<a name="l00027"></a>00027 <span class="comment">* permitted with respect to any software provided in binary form.</span>
<a name="l00028"></a>00028 <span class="comment">*</span>
<a name="l00029"></a>00029 <span class="comment">* *       any redistribution and use are licensed by TI for use only with TI Devices.</span>
<a name="l00030"></a>00030 <span class="comment">*</span>
<a name="l00031"></a>00031 <span class="comment">* *       Nothing shall obligate TI to provide you with source code for the software</span>
<a name="l00032"></a>00032 <span class="comment">* licensed and provided to you in object code.</span>
<a name="l00033"></a>00033 <span class="comment">*</span>
<a name="l00034"></a>00034 <span class="comment">* If software source code is provided to you, modification and redistribution of the</span>
<a name="l00035"></a>00035 <span class="comment">* source code are permitted provided that the following conditions are met:</span>
<a name="l00036"></a>00036 <span class="comment">*</span>
<a name="l00037"></a>00037 <span class="comment">* *       any redistribution and use of the source code, including any resulting derivative</span>
<a name="l00038"></a>00038 <span class="comment">* works, are licensed by TI for use only with TI Devices.</span>
<a name="l00039"></a>00039 <span class="comment">*</span>
<a name="l00040"></a>00040 <span class="comment">* *       any redistribution and use of any object code compiled from the source code</span>
<a name="l00041"></a>00041 <span class="comment">* and any resulting derivative works, are licensed by TI for use only with TI Devices.</span>
<a name="l00042"></a>00042 <span class="comment">*</span>
<a name="l00043"></a>00043 <span class="comment">* Neither the name of Texas Instruments Incorporated nor the names of its suppliers</span>
<a name="l00044"></a>00044 <span class="comment">*</span>
<a name="l00045"></a>00045 <span class="comment">* may be used to endorse or promote products derived from this software without</span>
<a name="l00046"></a>00046 <span class="comment">* specific prior written permission.</span>
<a name="l00047"></a>00047 <span class="comment">*</span>
<a name="l00048"></a>00048 <span class="comment">* DISCLAIMER.</span>
<a name="l00049"></a>00049 <span class="comment">*</span>
<a name="l00050"></a>00050 <span class="comment">* THIS SOFTWARE IS PROVIDED BY TI AND TI&apos;S LICENSORS &quot;AS IS&quot; AND ANY EXPRESS</span>
<a name="l00051"></a>00051 <span class="comment">* OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES</span>
<a name="l00052"></a>00052 <span class="comment">* OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.</span>
<a name="l00053"></a>00053 <span class="comment">* IN NO EVENT SHALL TI AND TI&apos;S LICENSORS BE LIABLE FOR ANY DIRECT, INDIRECT,</span>
<a name="l00054"></a>00054 <span class="comment">* INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,</span>
<a name="l00055"></a>00055 <span class="comment">* BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,</span>
<a name="l00056"></a>00056 <span class="comment">* DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY</span>
<a name="l00057"></a>00057 <span class="comment">* OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE</span>
<a name="l00058"></a>00058 <span class="comment">* OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED</span>
<a name="l00059"></a>00059 <span class="comment">* OF THE POSSIBILITY OF SUCH DAMAGE.</span>
<a name="l00060"></a>00060 <span class="comment">*</span>
<a name="l00061"></a>00061 <span class="comment">*/</span>
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 
<a name="l00105"></a>00105 <span class="preprocessor">#include &lt;stdio.h&gt;</span>
<a name="l00106"></a>00106 <span class="preprocessor">#include &lt;VX/vx.h&gt;</span>
<a name="l00107"></a>00107 <span class="preprocessor">#include &lt;<a class="code" href="bmp__rd__wr_8h.html">bmp_rd_wr.h</a>&gt;</span>
<a name="l00108"></a>00108 <span class="preprocessor">#include &lt;<a class="code" href="utility_8h.html">utility.h</a>&gt;</span>
<a name="l00109"></a>00109 
<a name="l00111"></a><a class="code" href="vx__tutorial__image__crop__roi_8c.html#a8118656bb5a60090a1dbffa402168438">00111</a> <span class="preprocessor">#define IN_FILE_NAME       &quot;colors.bmp&quot;</span>
<a name="l00112"></a>00112 <span class="preprocessor"></span>
<a name="l00114"></a><a class="code" href="vx__tutorial__image__crop__roi_8c.html#a75506823f0db0ef3f4f022cf132dbbbb">00114</a> <span class="preprocessor">#define OUT_FILE_NAME      &quot;vx_tutorial_image_crop_roi.bmp&quot;</span>
<a name="l00115"></a>00115 <span class="preprocessor"></span>
<a name="l00116"></a>00116 vx_image  <a class="code" href="vx__tutorial__image__crop__roi_8c.html#a4295a6029fd44a53594f2886c414902d" title="Load image from handle from file.">load_image_from_handle_from_file</a>(
<a name="l00117"></a>00117             vx_context context,
<a name="l00118"></a>00118             <span class="keywordtype">char</span> *filename,
<a name="l00119"></a>00119             vx_bool convert_to_gray_scale,
<a name="l00120"></a>00120             <span class="keywordtype">void</span> **bmp_file_context);
<a name="l00121"></a>00121 
<a name="l00125"></a><a class="code" href="vx__tutorial__image__crop__roi_8c.html#a2e40fa229aa1f3c5666a2c8f36de0e1d">00125</a> <span class="keywordtype">void</span> <a class="code" href="vx__tutorial__image__crop__roi_8c.html#a2e40fa229aa1f3c5666a2c8f36de0e1d" title="Tutorial Entry Point.">vx_tutorial_image_crop_roi</a>()
<a name="l00126"></a>00126 {
<a name="l00134"></a>00134     vx_context context;
<a name="l00135"></a>00135     vx_image image, roi_image;
<a name="l00136"></a>00136     vx_uint32 width, height;
<a name="l00137"></a>00137     vx_rectangle_t rect;
<a name="l00139"></a>00139     <span class="keywordtype">void</span> *bmp_file_context;
<a name="l00140"></a>00140 
<a name="l00141"></a>00141     printf(<span class="stringliteral">&quot; vx_tutorial_image_crop_roi: Tutorial Started !!! \n&quot;</span>);
<a name="l00142"></a>00142 
<a name="l00150"></a>00150     context = vxCreateContext();
<a name="l00153"></a>00153     printf(<span class="stringliteral">&quot; Loading file %s ...\n&quot;</span>, <a class="code" href="vx__tutorial__image__load__save_8c.html#a8118656bb5a60090a1dbffa402168438" title="Input file name.">IN_FILE_NAME</a>);
<a name="l00154"></a>00154 
<a name="l00155"></a>00155     image = <a class="code" href="vx__tutorial__image__crop__roi_8c.html#a4295a6029fd44a53594f2886c414902d" title="Load image from handle from file.">load_image_from_handle_from_file</a>(context, <a class="code" href="vx__tutorial__image__load__save_8c.html#a8118656bb5a60090a1dbffa402168438" title="Input file name.">IN_FILE_NAME</a>, vx_false_e, &amp;bmp_file_context);
<a name="l00156"></a>00156 
<a name="l00157"></a>00157     vxSetReferenceName((vx_reference)image, <span class="stringliteral">&quot;ORIGINAL&quot;</span>);
<a name="l00158"></a>00158 
<a name="l00166"></a>00166     <a class="code" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes</a>(image);
<a name="l00169"></a>00169     vxQueryImage(image, VX_IMAGE_WIDTH, &amp;width, <span class="keyword">sizeof</span>(vx_uint32));
<a name="l00170"></a>00170     vxQueryImage(image, VX_IMAGE_HEIGHT, &amp;height, <span class="keyword">sizeof</span>(vx_uint32));
<a name="l00171"></a>00171 
<a name="l00172"></a>00172     rect.start_x = width/4;
<a name="l00173"></a>00173     rect.start_y = height/4;
<a name="l00174"></a>00174     rect.end_x   = rect.start_x + width/2;
<a name="l00175"></a>00175     rect.end_y   = rect.start_y + height/2;
<a name="l00176"></a>00176 
<a name="l00183"></a>00183     roi_image = vxCreateImageFromROI(image, &amp;rect);
<a name="l00184"></a>00184 
<a name="l00185"></a>00185     vxSetReferenceName((vx_reference)roi_image, <span class="stringliteral">&quot;CROP_ROI&quot;</span>);
<a name="l00186"></a>00186 
<a name="l00194"></a>00194     <a class="code" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes</a>(roi_image);
<a name="l00197"></a>00197     printf(<span class="stringliteral">&quot; Saving to file %s ...\n&quot;</span>, <a class="code" href="vx__tutorial__image__load__save_8c.html#a75506823f0db0ef3f4f022cf132dbbbb" title="Output file name.">OUT_FILE_NAME</a>);
<a name="l00198"></a>00198 
<a name="l00207"></a>00207     <a class="code" href="utility_8h.html#a2ffb77a8e510c0236b07306d0eb47a30" title="Save data from image object to BMP file.">save_image_to_file</a>(<a class="code" href="vx__tutorial__image__load__save_8c.html#a75506823f0db0ef3f4f022cf132dbbbb" title="Output file name.">OUT_FILE_NAME</a>, roi_image);
<a name="l00216"></a>00216     vxReleaseImage(&amp;roi_image);
<a name="l00217"></a>00217     vxReleaseImage(&amp;image);
<a name="l00220"></a>00220     <span class="comment">/* now it is safe to release the memory passed to the image</span>
<a name="l00221"></a>00221 <span class="comment">     * NOTE: &quot;roi_image&quot; also holds a reference to the memory since</span>
<a name="l00222"></a>00222 <span class="comment">     *       its created from the &quot;image&quot;</span>
<a name="l00223"></a>00223 <span class="comment">     *       Hence memory passed to &quot;image&quot; should be freed after &quot;roi_image&quot;</span>
<a name="l00224"></a>00224 <span class="comment">     *       is released</span>
<a name="l00225"></a>00225 <span class="comment">     */</span>
<a name="l00226"></a>00226     <a class="code" href="bmp__rd__wr_8h.html#a2a612b23e595a4ac11ba207c88c03be6" title="Free memory allocated during bmp_file_read.">bmp_file_read_release</a>(bmp_file_context);
<a name="l00227"></a>00227 
<a name="l00236"></a>00236     vxReleaseContext(&amp;context);
<a name="l00239"></a>00239     printf(<span class="stringliteral">&quot; vx_tutorial_image_crop_roi: Tutorial Done !!! \n&quot;</span>);
<a name="l00240"></a>00240     printf(<span class="stringliteral">&quot; \n&quot;</span>);
<a name="l00241"></a>00241 }
<a name="l00242"></a>00242 
<a name="l00254"></a><a class="code" href="vx__tutorial__image__crop__roi_8c.html#a4295a6029fd44a53594f2886c414902d">00254</a> vx_image  <a class="code" href="vx__tutorial__image__crop__roi_8c.html#a4295a6029fd44a53594f2886c414902d" title="Load image from handle from file.">load_image_from_handle_from_file</a>(
<a name="l00255"></a>00255             vx_context context,
<a name="l00256"></a>00256             <span class="keywordtype">char</span> *filename,
<a name="l00257"></a>00257             vx_bool convert_to_gray_scale,
<a name="l00258"></a>00258             <span class="keywordtype">void</span> **bmp_file_context)
<a name="l00259"></a>00259 {
<a name="l00260"></a>00260     vx_image image = NULL;
<a name="l00261"></a>00261     uint32_t width, height, stride;
<a name="l00262"></a>00262     vx_df_image df;
<a name="l00263"></a>00263     vx_status status;
<a name="l00264"></a>00264     <span class="keywordtype">void</span> *data_ptr;
<a name="l00265"></a>00265 
<a name="l00266"></a>00266     status = <a class="code" href="bmp__rd__wr_8h.html#a9fd09ad0e348951c4af9dbb4c852cfd5" title="Read data from BMP file.">bmp_file_read</a>(
<a name="l00267"></a>00267                 filename,
<a name="l00268"></a>00268                 convert_to_gray_scale,
<a name="l00269"></a>00269                 &amp;width, &amp;height, &amp;stride, &amp;df, &amp;data_ptr,
<a name="l00270"></a>00270                 bmp_file_context);
<a name="l00271"></a>00271 
<a name="l00272"></a>00272     <span class="keywordflow">if</span>(status==VX_SUCCESS)
<a name="l00273"></a>00273     {
<a name="l00274"></a>00274         vx_imagepatch_addressing_t image_addr[1];
<a name="l00275"></a>00275         <span class="keywordtype">void</span> *ptrs[1];
<a name="l00276"></a>00276         uint32_t bpp;
<a name="l00277"></a>00277 
<a name="l00278"></a>00278         <span class="keywordflow">if</span>( df == VX_DF_IMAGE_U8 )
<a name="l00279"></a>00279             bpp = 1;
<a name="l00280"></a>00280         <span class="keywordflow">else</span>
<a name="l00281"></a>00281         <span class="keywordflow">if</span>( df == VX_DF_IMAGE_RGB )
<a name="l00282"></a>00282             bpp = 3;
<a name="l00283"></a>00283         <span class="keywordflow">else</span>
<a name="l00284"></a>00284         <span class="keywordflow">if</span>( df == VX_DF_IMAGE_RGBX )
<a name="l00285"></a>00285             bpp = 4;
<a name="l00286"></a>00286         <span class="keywordflow">else</span>
<a name="l00287"></a>00287             bpp = 1; <span class="comment">/* it should not reach here for BMP files */</span>
<a name="l00288"></a>00288 
<a name="l00289"></a>00289         image_addr[0].dim_x = width;
<a name="l00290"></a>00290         image_addr[0].dim_y = height;
<a name="l00291"></a>00291         image_addr[0].stride_x = bpp;
<a name="l00292"></a>00292         image_addr[0].stride_y = stride;
<a name="l00293"></a>00293         image_addr[0].scale_x = VX_SCALE_UNITY;
<a name="l00294"></a>00294         image_addr[0].scale_y = VX_SCALE_UNITY;
<a name="l00295"></a>00295         image_addr[0].step_x = 1;
<a name="l00296"></a>00296         image_addr[0].step_y = 1;
<a name="l00297"></a>00297 
<a name="l00298"></a>00298         ptrs[0] = data_ptr;
<a name="l00299"></a>00299 
<a name="l00306"></a>00306         image = vxCreateImageFromHandle(context, df, image_addr, ptrs, VX_MEMORY_TYPE_HOST);
<a name="l00309"></a>00309         <span class="comment">/* MUST not free memory that is passed to vxCreateImageFromHandle, until</span>
<a name="l00310"></a>00310 <span class="comment">         * that memory ptr is swapped out from the image</span>
<a name="l00311"></a>00311 <span class="comment">         * or the image handle is released</span>
<a name="l00312"></a>00312 <span class="comment">         */</span>
<a name="l00313"></a>00313         <span class="comment">/* bmp_file_read_release(bmp_file_context); */</span>
<a name="l00314"></a>00314     }
<a name="l00315"></a>00315     <span class="keywordflow">return</span> image;
<a name="l00316"></a>00316 }
<a name="l00317"></a>00317 
</pre></div></div>

<html>
<table bordercolor="#FFFFFF" bgcolor="#FFFFFF" width="100%">
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000"><b><i>
        &copy Copyright 2017 Texas Instruments Incorporated. All rights reserved. </i></b></font></td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000">
        Document generated by <b><i> doxygen </i></b> 1.6.1
  </font></td>
</tr>
</table>
